%global vpxtarget generic-gnu
%ifarch x86_64
%global vpxtarget x86_64-linux-gcc
%endif

%ifarch aarch64
%global vpxtarget arm64-linux-gcc
%endif

Summary:       VP8/VP9 Video Codec SDK
Name:          libvpx
Version:       1.14.1
Release:       2%{?dist}
License:       BSD
URL:           http://www.webmproject.org/code/
Source0:       https://github.com/webmproject/libvpx/archive/v%{version}.tar.gz
Source1:       vpx_config.h
Source2:       libvpx.ver

Patch3000:     libvpx-1.7.0-leave-fortify-source-on.patch

BuildRequires: make gcc gcc-c++ doxygen php-cli perl(Getopt::Long)

%ifarch x86_64
BuildRequires: yasm
%endif

%description
libvpx provides the VP8/VP9 SDK, which allows you to integrate your applications with the VP8 and VP9
video codecs, high quality, royalty free, open source codecs deployed on millions of computers and devices worldwide. 

%package devel
Summary:        Development files for libvpx
Requires:        %{name} = %{version}-%{release}

%description devel
Development libraries and headers for developing software against 
libvpx.

%package utils
Summary:        VP8 utilities and tools
Requires:        %{name} = %{version}-%{release}

%description utils
A selection of utilities and tools for VP8, including a sample encoder
and decoder.

%prep
%autosetup -n libvpx-%{version} -p1

%build
./configure --target=%{vpxtarget} \
    --enable-pic --disable-install-srcs \
    --enable-vp9-decoder --enable-vp9-encoder \
    --enable-experimental \
    --enable-vp9-highbitdepth \
    --enable-debug \
    --enable-shared \
    --enable-install-srcs \
    --prefix=%{_prefix} --libdir=%{_libdir} --size-limit=16384x16384

%make_build

%install
make DIST_DIR=%{buildroot}%{_prefix} dist

mv %{buildroot}%{_prefix}/docs doc/

pushd %{buildroot}
rm -rf .%{_prefix}/build/ .%{_prefix}/md5sums.txt .%{_libdir}*/*.a .%{_prefix}/CHANGELOG .%{_prefix}/README
mv .%{_bindir}/examples/* .%{_bindir}
rm -rf .%{_bindir}/examples

mv .%{_bindir}/postproc .%{_bindir}/vp8_postproc
mv .%{_bindir}/simple_decoder .%{_bindir}/vp8_simple_decoder
mv .%{_bindir}/simple_encoder .%{_bindir}/vp8_simple_encoder
mv .%{_bindir}/twopass_encoder .%{_bindir}/vp8_twopass_encoder
chmod 755 .%{_bindir}/*
popd

%ifarch ppc64 ppc64le
cp -a vpx_config.h %{buildroot}%{_includedir}/vpx/vpx_config-ppc64.h
%else
cp -a vpx_config.h %{buildroot}%{_includedir}/vpx/vpx_config-%{_arch}.h
%endif

cp %{SOURCE1} %{buildroot}%{_includedir}/vpx/vpx_config.h
touch -r AUTHORS %{buildroot}%{_includedir}/vpx/vpx_config.h

mv %{buildroot}%{_prefix}/src/vpx_dsp %{buildroot}%{_includedir}/
mv %{buildroot}%{_prefix}/src/vpx_mem %{buildroot}%{_includedir}/
mv %{buildroot}%{_prefix}/src/vpx_ports %{buildroot}%{_includedir}/
mv %{buildroot}%{_prefix}/src/vpx_scale %{buildroot}%{_includedir}/

rm -rf %{buildroot}%{_prefix}/src

%files
%license LICENSE
%doc AUTHORS CHANGELOG README
%{_libdir}/libvpx.so.*

%files devel
%{_includedir}/vpx/
%{_includedir}/vpx_dsp/
%{_includedir}/vpx_mem/
%{_includedir}/vpx_ports/
%{_includedir}/vpx_scale/
%{_libdir}/pkgconfig/vpx.pc
%{_libdir}/libvpx.so

%files utils
%{_bindir}/*

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.14.1-2
- Rebuilt for loongarch release

* Mon Jun 17 2024 Upgrade Robot <upbot@opencloudos.tech> - 1.14.1-1
- Upgrade to version 1.14.1
- fix CVE: CVE-2024-5197

* Fri Dec 8 2023 Jiaxin Yang <jiaxinyyang@tencent.com> - 1.13.1-1
- Fix bug with smaller width bigger size, resolve CVE-2023-44488
- VP8: disallow thread count changes, resolve CVE-2023-5217

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.13.0-3
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Sep 04 2023 Miaojun Dong <zoedong@tencent.com> - 1.13.0-2
- Rebuild for php-8.2.9

* Wed Aug 23 2023 Shuo Wang <abushwang@tencent.com> - 1.13.0-1
- update to 1.13.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.12.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.12.0-2
- Rebuilt for OpenCloudOS Stream 23

* Fri Dec 9 2022 Shuo Wang <abushwang@tencent.com> - 1.12.0-1
- initial build

